/* eslint-disable max-len */
import {msecs, seconds} from './lib/duration';
import {Attempt, ExponentialBackOffRetryPolicy, SimpleRetryPolicy} from './index';

/* eslint-disable require-jsdoc */
class Application {
  run(): Promise<String> {
    throw new Error('Always thrown error...');
  }
}

const main = async () => {
  const simpleRetry = SimpleRetryPolicy.ofDefaults();
  SimpleRetryPolicy.newBuilder()
      .duration(seconds(1))
      .build();

  const exponentialBackOffRetryPolicy =
    new ExponentialBackOffRetryPolicy(msecs(1000), 4, 2);

  new Attempt(simpleRetry).execute(() => (new Application().run()));

  return await new Attempt(exponentialBackOffRetryPolicy).executeAsync(async () => {
    return new Application().run();
  });
};

main().then((v) => console.log(v)).catch((e) => console.error(e));
